package view;

import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;

import model.*;

/**
 * A GUI for the number generator classes
 * 
 * @author Uno Holmer 
 * @version 2008-01-24
 */

public class UserInterface 
{
    private JFrame frame;

    public UserInterface(PrimeGenerator primeGen,FibonacciGenerator fibGen)
    {
        frame = new JFrame("Number generator");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        
        JPanel contentPane = (JPanel)frame.getContentPane();
        contentPane.setLayout(new GridLayout(1,2,10,10));
        contentPane.setBorder(new EmptyBorder(30, 30, 30, 30));
        
        // A number pane is a push button and a associated output label
        contentPane.add(new NumberPane("Next prime number",primeGen));
        contentPane.add(new NumberPane("Next Fibonacci number",fibGen));
        
        frame.pack();
        Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
        frame.setLocation(d.width/2 - frame.getWidth()/2, d.height/2 - frame.getHeight()/2);
        frame.setVisible(true);
    }
}
